{
  MetaData Example
    Loading & Editing Wma File Tags

    Available Fields:
    ================

    Encoder, Genre, Author, Title, Album, Composer,
    Url, Track, Year, CopyRight, Comments, Lyrics.

    Read Only Fields: Version, Duration, BitRate, FileSize, VBR.

    (C) 2004 Copyright Philip Hadar - Israel
        Philip@EverX.co.il
        WWW.EverX.co.il

   modifications / Delphi-Header by Chris Tr?ken


   (No MetaData.DLL is needed)
}

// Bug Fix it seams that sometimes the TagHeader will show wrong Durations
// Now the Duration is a simple Calculation (more acurate)

unit WMAReader;

interface
uses
  SysUtils,
  Windows,
  Dialogs;

type

  TTagsData = packed record
    Encoder, Version, Genre, Author, Title, Album,
    Composer, Url, Track, Year, CopyRight: string[255];
    Comments, Lyrics: WideString;
    BitRate, FileSize: LongInt;
    Duration : Integer;
    VBR: Boolean;
  end;
  PTagsData = ^TTagsData;


procedure OpenWMAFile(FileName: string;TagsData : PTagsData);
procedure SaveWMAFile(TagsData : PTagsData) ;
function  DurationToStr(Duration: integer; ShowMs: boolean): string;

implementation
//{$R *.RES}

const
  IID_IWMMetadataEditor: TGUID = '{96406bd9-2b2b-11d3-b36b-00c04f6108ff}';
  IID_IWMHeaderInfo: TGUID = '{96406bda-2b2b-11d3-b36b-00c04f6108ff}';
  IID_IWMHeaderInfo3: TGUID = '{15CC68E3-27CC-4ecd-B222-3F5D02D80BD5}';
  IID_IWMHeaderInfo2: TGUID = '{15cf9781-454e-482e-b393-85fae487a810}';

  LibName = 'WMVCORE.DLL';

var
 fFileName : PWideChar;

type

  WMT_CODEC_INFO_TYPE = LongWord;

  WMT_ATTR_DATATYPE =
    (WMT_TYPE_DWORD,
    WMT_TYPE_STRING,
    WMT_TYPE_BINARY,
    WMT_TYPE_BOOL,
    WMT_TYPE_QWORD,
    WMT_TYPE_WORD,
    WMT_TYPE_GUID);

  TWMTAttrDataType = WMT_ATTR_DATATYPE;

type
  IWMMetadataEditor = interface(IUnknown)
    ['{96406BD9-2B2B-11d3-B36B-00C04F6108FF}']
    function Open(pwszFilename: PWideChar): HRESULT; stdcall;
    function Close: HRESULT; stdcall;
    function Flush: HRESULT; stdcall;
  end;


type
  IWMHeaderInfo = interface(IUnknown)
    ['{96406BDA-2B2B-11d3-B36B-00C04F6108FF}']
    function GetAttributeCount(wStreamNum: Word; out pcAttributes: Word): HRESULT; stdcall;
    function GetAttributeByIndex(wIndex: Word; var pwStreamNum: Word;
      pwszName: PWideChar; var pcchNameLen: Word;
      out pType: TWMTAttrDataType; pValue: PBYTE;
      var pcbLength: Word): HRESULT; stdcall;
    function GetAttributeByName(var pwStreamNum: Word; pszName: PWideChar;
      out pType: TWMTAttrDataType; pValue: PBYTE;
      var pcbLength: Word): HRESULT; stdcall;
    function SetAttribute(wStreamNum: Word; pszName: PWideChar;
      Type_: TWMTAttrDataType; {in} pValue: PBYTE;
      cbLength: Word): HRESULT; stdcall;
    function GetMarkerCount(out pcMarkers: Word): HRESULT; stdcall;
    function GetMarker(wIndex: Word; pwszMarkerName: PWideChar;
      var pcchMarkerNameLen: Word; out pcnsMarkerTime: Int64): HRESULT; stdcall;
    function AddMarker(pwszMarkerName: PWideChar; cnsMarkerTime: Int64): HRESULT; stdcall;
    function RemoveMarker(wIndex: Word): HRESULT; stdcall;
    function GetScriptCount(out pcScripts: Word): HRESULT; stdcall;
    function GetScript(wIndex: Word; pwszType: PWideChar;
      var pcchTypeLen: Word; pwszCommand: PWideChar;
      var pcchCommandLen: Word; out pcnsScriptTime: Int64): HRESULT; stdcall;
    function AddScript(pwszType, pwszCommand: PWideChar;
      cnsScriptTime: Int64): HRESULT; stdcall;
    function RemoveScript(wIndex: Word): HRESULT; stdcall;
  end;

type
  IWMHeaderInfo2 = interface(IWMHeaderInfo)
    ['{15CF9781-454E-482e-B393-85FAE487A810}']
    function GetCodecInfoCount(out pcCodecInfos: LongWord): HRESULT; stdcall;
    function GetCodecInfo(wIndex: LongWord; var pcchName: Word;
      pwszName: PWideChar; var pcchDescription: Word;
      pwszDescription: PWideChar; out pCodecType: WMT_CODEC_INFO_TYPE;
      var pcbCodecInfo: Word; pbCodecInfo: PBYTE): HRESULT; stdcall;
  end;

type
  IWMHeaderInfo3 = interface(IWMHeaderInfo2)
    ['{15CC68E3-27CC-4ecd-B222-3F5D02D80BD5}']
    function GetAttributeCountEx(wStreamNum: Word; out pcAttributes: Word): HRESULT; stdcall;
    function GetAttributeIndices(wStreamNum: Word; pwszName: PWideChar;
      pwLangIndex: PWORD; pwIndices: PWORD; var pwCount: Word): HRESULT; stdcall;
    function GetAttributeByIndexEx(wStreamNum: Word; wIndex: Word; pwszName: PWideChar;
      var pwNameLen: Word; out pType: TWMTAttrDataType; out pwLangIndex: Word;
      pValue: PBYTE; var pdwDataLength: LongWord): HRESULT; stdcall;
    function ModifyAttribute(wStreamNum: Word; wIndex: Word; Type_: TWMTAttrDataType;
      wLangIndex: Word; pValue: PBYTE; dwLength: LongWord): HRESULT; stdcall;
    function AddAttribute(wStreamNum: Word; pszName: PWideChar;
      out pwIndex: Word; Type_: TWMTAttrDataType; wLangIndex: Word;
      pValue: PBYTE; dwLength: LongWord): HRESULT; stdcall;
    function DeleteAttribute(wStreamNum, wIndex: Word): HRESULT; stdcall;
    function AddCodecInfo(pwszName: PWideChar; pwszDescription: PWideChar;
      codecType: WMT_CODEC_INFO_TYPE; cbCodecInfo: Word;
      pbCodecInfo: PBYTE): HRESULT; stdcall;
  end;

var
  _WMCreateEditor: function(out ppEditor: IWMMetadataEditor): HRESULT; stdcall;
  DllHandle: THandle;
  ppEditor: IWMMetadataEditor;
  ppHeaderInfo3: IWMHeaderInfo3;

  WMResult: HRESULT;

procedure ResetTagsData(TagsData: PTagsData);
begin

  TagsData.Duration := 0;
  TagsData.BitRate := 0;
  TagsData.FileSize := 0;
  TagsData.Encoder := '';
  TagsData.Version := '';
  TagsData.Genre := '';
  TagsData.Author := '';
  TagsData.Composer := '';
  TagsData.Title := '';
  TagsData.Album := '';
  TagsData.Year := '';
  TagsData.Track := '';
  TagsData.Url := '';
  TagsData.Comments := '';
  TagsData.Lyrics := '';
  TagsData.CopyRight := '';

end;

function GetAttribIndex(Attrib: string): Integer;
var
  AttribName: PWideChar;
  P, Lang: PWord;
  AttribLen: Word;
begin

  Result := -1;

  AttribName := StringToOleStr(Attrib);
  Lang := PWord(0);

  ppHeaderInfo3.GetAttributeIndices($FFFF, AttribName, Lang, nil, AttribLen);

  if AttribLen <> 0 then
  begin
    P := AllocMem(AttribLen);

    try
      ppHeaderInfo3.GetAttributeIndices($FFFF, AttribName, Lang, P, AttribLen);
      Result := PWord(P)^;
    finally
      FreeMem(P);
    end;

  end;


end;

function ShowTags(var FileName: PWideChar; var TagsData: PTagsData): Boolean; stdcall;
var
  AttribStream, AttributeCount, AttribLen: Word;
  AttribName: PWideChar;
  pType: TWMTAttrDataType;
  pValue: PByte;
  DataLen: Word;
  I, nSize: Integer;
  HR: HRESULT;
  nVal: Integer;
  P: PInteger;
  Duration: Int64;
begin

  DllHandle := LoadLibrary(LibName);

  if DllHandle = 0 then
  begin
    ShowMessage(Format('Could not Load Library ($%x).', [DllHandle]));
    Result := False;
    Exit;
  end
  else
    _WMCreateEditor := GetProcAddress(DllHandle, 'WMCreateEditor');

  ResetTagsData(TagsData);

  if not FileExists(FileName) then
  begin
    raise Exception.Create(Format('The file' + #13#10 + '%S' + #13#10 + 'does''nt exists!', [FileName]));
    Exit;
  end;

  try

    HR := _WMCreateEditor(ppEditor);

    if Failed(HR) then
    begin
      Result := False;
      raise Exception.Create(Format('Could not create Metadata Editor ($%x).', [HR]));
      Exit;
    end;

    ppEditor.Open(FileName);

    HR := ppEditor.QueryInterface(IID_IWMHeaderInfo3, ppHeaderInfo3);

    if Failed(HR) then
    begin
      Result := False;
      raise Exception.Create(Format('Could not QI for IWMHeaderInfo3 ($%x).', [HR]));
      Exit;
    end;

    Result := True;

    AttribStream := 0;

    ppHeaderInfo3.GetAttributeCount(AttribStream, AttributeCount);

    for I := 0 to AttributeCount - 1 do
    begin

      ppHeaderInfo3.GetAttributeByIndex(Word(I), AttribStream, nil, AttribLen, pType, nil, DataLen);

      nSize := 255;
      AttribName := AllocMem(nSize * 2);
      AttribLen := nSize;
      PValue := AllocMem(DataLen);

      ppHeaderInfo3.GetAttributeByIndex(Word(I), AttribStream, PWideChar(AttribName), AttribLen, pType, PByte(PValue), DataLen);

      if pType = WMT_TYPE_STRING then
      begin

        if UpperCase(AttribName) = 'WM/ENCODEDBY' then
          TagsData.Encoder := Widestring(PValue);

        if UpperCase(AttribName) = 'WMFSDKVERSION' then
          TagsData.Version := Widestring(PValue);

        if UpperCase(AttribName) = 'WM/GENRE' then
          TagsData.Genre := Widestring(PValue);

        if UpperCase(AttribName) = 'AUTHOR' then
          TagsData.Author := Widestring(PValue);

        if UpperCase(AttribName) = 'TITLE' then
          TagsData.Title := Widestring(PValue);

        if UpperCase(AttribName) = 'WM/ALBUMTITLE' then
          TagsData.Album := Widestring(PValue);

        if UpperCase(AttribName) = 'WM/COMPOSER' then
          TagsData.Composer := Widestring(PValue);

        if UpperCase(AttribName) = 'WM/URL' then
          TagsData.Url := Widestring(PValue);

        if UpperCase(AttribName) = 'WM/YEAR' then
          TagsData.Year := Widestring(PValue);

        if UpperCase(AttribName) = 'WM/TRACKNUMBER' then
          TagsData.Track := Widestring(PValue);

        if UpperCase(AttribName) = 'DESCRIPTION' then
        begin
          TagsData.Comments := Widestring(PValue);
        end;

        if UpperCase(AttribName) = 'WM/LYRICS' then
          TagsData.Lyrics := PWideChar(PValue);

        if UpperCase(AttribName) = 'COPYRIGHT' then
          TagsData.CopyRight := Widestring(PValue);

      end;

       if pType = WMT_TYPE_BOOL then
        if UpperCase(AttribName) = 'ISVBR' then
        begin
          nVal := pValue^;
          TagsData.VBR := (nVal <> 0);
        end;

      if pType = WMT_TYPE_DWORD then
      begin
        P := PInteger(PValue);
        nVal := P^;

        if UpperCase(AttribName) = 'BITRATE' then
          TagsData.BitRate := nVal;

      end;

      if pType = WMT_TYPE_QWORD then
      begin
        P := PInteger(PValue);
        nVal := P^;

        if UpperCase(AttribName) = 'FILESIZE' then
          TagsData.FileSize := nVal;

       { if UpperCase(AttribName) = 'DURATION' then
        begin

          Duration := abs(nVal div 10000000);
          TagsData.Duration := Duration;
          
        end; }

      end;
       // it seams that sometimes the Tag Header will Show a wrong Duration
       // This is a simple Calculation
       if (TagsData.FileSize > 0) and (TagsData.BitRate > 0) then
         TagsData.Duration := round((TagsData.FileSize * 8)/ (TagsData.BitRate / 1000)/ 1000)
       else
         TagsData.Duration := 0;


      FreeMem(AttribName);
      FreeMem(PValue);

    end;

    ppHeaderInfo3 := nil;

  finally

    ppEditor.Close;
    ppEditor := nil;

    if DllHandle <> 0 then
    begin
      FreeLibrary(DllHandle);
      _WMCreateEditor := nil;
    end;

  end;

end;

function SaveTags(var FileName: PWideChar; var TagsData: PTagsData): Boolean; stdcall;
var
  nIndex, nLength: Integer;
  AttribName, pValue: PWideChar;
  pwIndex: Word;
  HR: HRESULT;
 // WMResult: HRESULT;
begin
// Modified : Result value will be True only if the whole process is done successfully.
//  by Silhwan Hyun

  Result := False;
  WMResult := 0;

  if not FileExists(FileName) then
  begin
    raise Exception.Create(Format('The file' + #13#10 + '%S' + #13#10 + 'does''nt exists!', [FileName]));
    Exit;
  end;

  DllHandle := LoadLibrary(LibName);

  if DllHandle = 0 then
  begin
    ShowMessage(Format('Could not Load Library ($%x).', [DllHandle]));
 //   Result := False;
    Exit;
  end
  else
    _WMCreateEditor := GetProcAddress(DllHandle, 'WMCreateEditor');

 // Result := True;

  HR := _WMCreateEditor(ppEditor);

  if Failed(HR) then
  begin
    raise Exception.Create(Format('Could not create Metadata Editor ($%x).', [HR]));
    Exit;
  end;

  HR := ppEditor.QueryInterface(IID_IWMHeaderInfo3, ppHeaderInfo3);

  if Failed(HR) then
  begin
    raise Exception.Create(Format('Could not QI for IWMHeaderInfo3 ($%x).', [HR]));
    Exit;
  end;

  ppEditor.Open(FileName);

  try


    AttribName := 'WM/EncodedBy';
    nIndex := GetAttribIndex(AttribName);
    pValue := StringToOleStr(TagsData.Encoder);
    nLength := Length(pValue) * 2;
    if nIndex >= 0 then      // nIndex = -1 : Specified attribute does not exist ?
    begin

      if TagsData.Encoder <> '' then
        WMResult := ppHeaderInfo3.ModifyAttribute(0, nIndex, WMT_TYPE_STRING, 0, PByte(pValue), nLength)
      else
        WMResult := ppHeaderInfo3.DeleteAttribute(0, nIndex);

    end
    else if nlength <> 0 then
      WMResult := ppHeaderInfo3.AddAttribute(0, AttribName, pwIndex, WMT_TYPE_STRING, 0, PByte(pValue), nLength);

    if WMResult = 0 then
    begin
    AttribName := 'WM/Genre';
    nIndex := GetAttribIndex(AttribName);
    pValue := StringToOleStr(TagsData.Genre);
    nLength := Length(pValue) * 2;
    if nIndex >= 0 then
    begin

      if TagsData.Genre <> '' then
        WMResult := ppHeaderInfo3.ModifyAttribute(0, nIndex, WMT_TYPE_STRING, 0, PByte(pValue), nLength)
      else
        WMResult := ppHeaderInfo3.DeleteAttribute(0, nIndex);

    end
    else if nlength <> 0 then
      WMResult := ppHeaderInfo3.AddAttribute(0, AttribName, pwIndex, WMT_TYPE_STRING, 0, PByte(pValue), nLength);
    end;

    if WMResult = 0 then
    begin
    AttribName := 'Author';
    nIndex := GetAttribIndex(AttribName);
    pValue := StringToOleStr(TagsData.Author);
    nLength := Length(pValue) * 2;
    if nIndex >= 0 then
    begin

      if TagsData.Author <> '' then
        WMResult := ppHeaderInfo3.ModifyAttribute(0, nIndex, WMT_TYPE_STRING, 0, PByte(pValue), nLength)
      else
        WMResult := ppHeaderInfo3.DeleteAttribute(0, nIndex);

    end
    else if nlength <> 0 then
      WMResult := ppHeaderInfo3.AddAttribute(0, AttribName, pwIndex, WMT_TYPE_STRING, 0, PByte(pValue), nLength);
    end;

    if WMResult = 0 then
    begin
    AttribName := 'WM/Composer';
    nIndex := GetAttribIndex(AttribName);
    pValue := StringToOleStr(TagsData.Composer);
    nLength := Length(pValue) * 2;
    if nIndex >= 0 then
    begin

      if TagsData.Composer <> '' then
        WMResult := ppHeaderInfo3.ModifyAttribute(0, nIndex, WMT_TYPE_STRING, 0, PByte(pValue), nLength)
      else
        WMResult := ppHeaderInfo3.DeleteAttribute(0, nIndex);

    end
    else if nlength <> 0 then
      WMResult := ppHeaderInfo3.AddAttribute(0, AttribName, pwIndex, WMT_TYPE_STRING, 0, PByte(pValue), nLength);
    end;

    if WMResult = 0 then
    begin
    AttribName := 'Title';
    nIndex := GetAttribIndex(AttribName);
    pValue := StringToOleStr(TagsData.Title);
    nLength := Length(pValue) * 2;
    if nIndex >= 0 then
    begin

      if TagsData.Title <> '' then
        WMResult := ppHeaderInfo3.ModifyAttribute(0, nIndex, WMT_TYPE_STRING, 0, PByte(pValue), nLength)
      else
        WMResult := ppHeaderInfo3.DeleteAttribute(0, nIndex);

    end
    else if nlength <> 0 then
      WMResult := ppHeaderInfo3.AddAttribute(0, AttribName, pwIndex, WMT_TYPE_STRING, 0, PByte(pValue), nLength);
    end;

    if WMResult = 0 then
    begin
    AttribName := 'WM/AlbumTitle';
    nIndex := GetAttribIndex(AttribName);
    pValue := StringToOleStr(TagsData.Album);
    nLength := Length(pValue) * 2;
    if nIndex >= 0 then
    begin

      if TagsData.Album <> '' then
        WMResult := ppHeaderInfo3.ModifyAttribute(0, nIndex, WMT_TYPE_STRING, 0, PByte(pValue), nLength)
      else
        WMResult := ppHeaderInfo3.DeleteAttribute(0, nIndex);

    end
    else if nlength <> 0 then
      WMResult := ppHeaderInfo3.AddAttribute(0, AttribName, pwIndex, WMT_TYPE_STRING, 0, PByte(pValue), nLength);
    end;

    if WMResult = 0 then
    begin
    AttribName := 'WM/Year';
    nIndex := GetAttribIndex(AttribName);
    pValue := StringToOleStr(TagsData.Year);
    nLength := Length(pValue) * 2;
    if nIndex >= 0 then
    begin

      if TagsData.Year <> '' then
        WMResult := ppHeaderInfo3.ModifyAttribute(0, nIndex, WMT_TYPE_STRING, 0, PByte(pValue), nLength)
      else
        WMResult := ppHeaderInfo3.DeleteAttribute(0, nIndex);

    end
    else if nlength <> 0 then
      WMResult := ppHeaderInfo3.AddAttribute(0, AttribName, pwIndex, WMT_TYPE_STRING, 0, PByte(pValue), nLength);
    end;

    if WMResult = 0 then
    begin
    AttribName := 'WM/TrackNumber';
    nIndex := GetAttribIndex(AttribName);
    pValue := StringToOleStr(TagsData.Track);
    nLength := Length(pValue) * 2;
    if nIndex >= 0 then
    begin

      if TagsData.Track <> '' then
        WMResult := ppHeaderInfo3.ModifyAttribute(0, nIndex, WMT_TYPE_STRING, 0, PByte(pValue), nLength)
      else
        WMResult := ppHeaderInfo3.DeleteAttribute(0, nIndex);

    end
    else if nlength <> 0 then
      WMResult := ppHeaderInfo3.AddAttribute(0, AttribName, pwIndex, WMT_TYPE_STRING, 0, PByte(pValue), nLength);
    end;

    if WMResult = 0 then
    begin
    AttribName := 'WM/URL';
    nIndex := GetAttribIndex(AttribName);
    pValue := StringToOleStr(TagsData.Url);
    nLength := Length(pValue) * 2;
    if nIndex >= 0 then
    begin

      if TagsData.Url <> '' then
        WMResult := ppHeaderInfo3.ModifyAttribute(0, nIndex, WMT_TYPE_STRING, 0, PByte(pValue), nLength)
      else
        WMResult := ppHeaderInfo3.DeleteAttribute(0, nIndex);

    end
    else if nlength <> 0 then
      WMResult := ppHeaderInfo3.AddAttribute(0, AttribName, pwIndex, WMT_TYPE_STRING, 0, PByte(pValue), nLength);
    end;

    if WMResult = 0 then
    begin
    AttribName := 'Copyright';
    nIndex := GetAttribIndex(AttribName);
    pValue := StringToOleStr(TagsData.Copyright);
    nLength := Length(pValue) * 2;
    if nIndex >= 0 then
    begin

      if TagsData.Copyright <> '' then
        WMResult := ppHeaderInfo3.ModifyAttribute(0, nIndex, WMT_TYPE_STRING, 0, PByte(pValue), nLength)
      else
        WMResult := ppHeaderInfo3.DeleteAttribute(0, nIndex);

    end
    else if nlength <> 0 then
      WMResult := ppHeaderInfo3.AddAttribute(0, AttribName, pwIndex, WMT_TYPE_STRING, 0, PByte(pValue), nLength);
    end;

    if WMResult = 0 then
    begin
    AttribName := 'Description';
    nIndex := GetAttribIndex(AttribName);
    pValue := StringToOleStr(TagsData.Comments);
    nLength := Length(pValue) * 2;
    if nIndex >= 0 then
    begin

      if TagsData.Comments <> '' then
        WMResult := ppHeaderInfo3.ModifyAttribute(0, nIndex, WMT_TYPE_STRING, 0, PByte(pValue), nLength)
      else
        WMResult := ppHeaderInfo3.DeleteAttribute(0, nIndex);

    end
    else if nlength <> 0 then
      WMResult := ppHeaderInfo3.AddAttribute(0, AttribName, pwIndex, WMT_TYPE_STRING, 0, PByte(pValue), nLength);
    end;

    if WMResult = 0 then
    begin
    AttribName := 'WM/Lyrics';
    nIndex := GetAttribIndex(AttribName);
    pValue := StringToOleStr(TagsData.Lyrics);
    nLength := Length(pValue) * 2;
    if nIndex >= 0 then
    begin

      if TagsData.Lyrics <> '' then
        WMResult := ppHeaderInfo3.ModifyAttribute(0, nIndex, WMT_TYPE_STRING, 0, PByte(pValue), nLength)
      else
        WMResult := ppHeaderInfo3.DeleteAttribute(0, nIndex);

    end
    else if nlength <> 0 then
      WMResult := ppHeaderInfo3.AddAttribute(0, AttribName, pwIndex, WMT_TYPE_STRING, 0, PByte(pValue), nLength);
    end;

    ppEditor.Flush;

    if WMResult = 0 then
       Result := True;

  finally

    ppHeaderInfo3 := nil;

    ppEditor.Close;
    ppEditor := nil;

    if DllHandle <> 0 then
    begin
      FreeLibrary(DllHandle);
      _WMCreateEditor := nil;
    end;

  end;

end;



procedure OpenWMAFile(FileName: string; TagsData : PTagsData);
begin
  if not FileExists(FileName) then exit;

  fFileName := StringToOleStr(FileName);

  if Not ShowTags(fFileName, TagsData) Then
  ShowMessage('Could Not Load Tags!');




end;

procedure SaveWMAFile(TagsData : PTagsData) ;
begin
  if Not SaveTags(fFileName, TagsData) Then
     if WMResult <> 0 then   // if WMResult = 0 then other error message already displayed
        ShowMessage('Could not save Tags ! (Check if the file is opened for other purpose.)');
end;

function DurationToStr(Duration: integer; ShowMs: boolean): string;
begin
  if ShowMs then
    Result := Format('%d:%2.2d,%3.3d', [(Abs(Duration div 60)), Abs(Duration mod 60), Abs(Duration mod 1000)])
  else
    Result := Format('%d:%2.2d', [(Abs(Duration div 60)), Abs(Duration mod 60)]);
end;




end.

